<template>
  <div class="[ bh-index-container ]">
    <!-- Filters Area -->
    <bh-filter-list-ui class="[ bh-filters ]" @changed="onFilterChange" />

    <!-- Bizcard List Area -->
    <bh-bizcard-list class="[ bh-bizcard-list ]" :filters="filters" />

    <!-- Details Area -->
    <nuxt-child :key="$route.fullPath" :filters="filters" keep-alive />
  </div>
</template>

<script>
export default {
  layout: 'authenticated',
  computed: {
    filters() {
      const { topics, types, geofocus } =
        this.$store.getters['filters/getSelectedFilters'];

      return {
        t: topics.join(',') || undefined,
        bt: types.join(',') || undefined,
        g: geofocus.join(',') || undefined,
      };
    },
  },
  methods: {
    onFilterChange() {
      const bizcardsCount =
        this.$store.getters['bizcards/getFilteredBizcardsCount'];

      if (bizcardsCount) {
        this.$router.push({ path: '/', query: this.filters });
      } else {
        this.$router.push({ path: '/no-filter-results', query: this.filters });
      }
    },
  },
};
</script>

<style lang="postcss">
/**
 * Mobile
 */
/* prettier-ignore */
.bh-index-container {
  --bh-container--my: theme('margin.6');
  --bh-container--row-gap: theme('spacing.4');
  --bh-container--column-gap: theme('spacing.6');
  --bh-container--h: calc(var(--ag-main-atf--h) - 2 * var(--bh-container--my));

  --bh-filters-area--h: calc(2 * theme('spacing.px') + 2 * theme('padding.2') + theme('height.6')); /* filter button h */
  --bh-filters-area--w: min(calc(100vw - 2 * theme('spacing.4')), 22.5rem);
  --bh-bizcard-list-area--h: calc(var(--bh-container--h) - var(--bh-filters-area--h) - var(--bh-container--row-gap));
  --bh-bizcard-details-area--h: calc(var(--ag-main-atf--h) - var(--bh-container--my));
  --bh-bizcard-details-area--w: 40rem;
}

/* prettier-ignore */
.bh-index-container {
  position: relative;
  margin-top: var(--bh-container--my);
  margin-bottom: var(--bh-container--my);

  display: grid;
  grid-template-areas:
    'filters'
    'bizcard-list';
  grid-template-columns:
    var(--bh-filters-area--w);
  grid-template-rows:
    var(--bh-filters-area--h)
    var(--bh-bizcard-list-area--h);
  row-gap: var(--bh-container--row-gap);
  justify-content: center;
}

.bh-filters {
  grid-area: filters;
}
.bh-bizcard-list {
  grid-area: bizcard-list;
}
[data-grid-area='details'] {
  position: absolute;
  z-index: 20;
}

/**
 * Tablet
 */
@screen sm {
  .bh-index-container {
    grid-template-columns: auto;
  }
}

/**
 * Desktop
 */
@screen ml {
  /* prettier-ignore */
  .bh-index-container {
    --bh-bizcard-details-area--h: var(--bh-bizcard-list-area--h);
    --bh-bizcard-details-area--w: 100%;

    grid-template-areas:
      'filters        .......'
      'bizcard-list   details';
    grid-template-columns:
      var(--bh-filters-area--w) 1fr;
    column-gap: var(--bh-container--column-gap);
  }

  [data-grid-area='details'] {
    grid-area: details;
    position: static;
  }
}
</style>
